<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Sep 3, 2013 2:37:36 PM
 * @version $Rev$
 */

use Carerix\Api\Rest\Entity\CREmployee;

/**
 * TellAFriend class
 * Used to ....
 */
class Entity_Form_Newsletter {
	
	private $interfacer = null;
	private $newsletter_id = 0;
	
	public function __construct($newsletter_id) {
		$this->interfacer = WP_Interfacer::getInstance();
		$this->newsletter_id = (int)$newsletter_id;
	}
	
	public function display()
	{
        $backtrace = debug_backtrace();
        foreach($backtrace as $bkt) {
            if(isset($bkt['file'])) {
                if(basename($bkt['file']) == 'class-frontend.php') return '';
            }
        }
		$data = array();
		
		$result = $this->process();
		
		$template = new Utils_Template('frontend/forms/newsletter');
		$template->with($data)->display();
	}
	
	private function process()
	{
		// $input_data = filter_input_array(INPUT_POST, FILTER_FLAG_STRIP_BACKTICK | FILTER_FLAG_ALLOW_OCTAL);
		$input_data = map_deep( wp_unslash($_POST), 'sanitize_textarea_field' );
		
		if(count($input_data) && wp_verify_nonce($input_data['_carerix_nonce_field'], 'newsletter'))
		{
			$emailAddress = $input_data['email'];
			$firstName = $input_data['firstName'];
			$lastName = $input_data['lastName'];
			
			$general_exception = false;
			try 
			{
				$user = new CREmployee();
				$user->setEmailAddress($emailAddress);
				$user->setFirstName($firstName);
				$user->setLastName($lastName);

				$user->setTransient(array('tid'=>$this->newsletter_id));
				$user->subscribe();
			}
			catch (Carerix\Api\Rest\Exception $care)
			{
				echo $care->getMessage();
			}
			catch (Exception $ex)
			{
				echo $ex->getMessage();
			}
			if($general_exception)
			{
				Utils_Log::write(Utils_Log::TYPE_NAS, $user, $general_exception);
			}
		}
	}
}