<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 9:29:42 AM
 * @version $Rev$
 */

/**
 * Job class
 * Used to ....
 */
class Entity_Writer_Job extends Entity_Writer {
	
	protected $type = WP_Constants::ENTITY_TYPE_JOB;
	protected $fragment = '';
	protected $categoryLanguage = false;
    protected $categoryKey = 'Publications';
	protected $cxfields = array();
    private $sourceData = array();


	public function __construct($dataDictionary, $customFieldDictionary = array())
	{
		parent::__construct($dataDictionary, $customFieldDictionary);
	}


	public function getContent() 
	{
		// Job shortcodes need to be processed for the backend for the Sources->"Publication Details Body" template
		$jobFrontend = new Frontend_Shortcode_Job();
		$superDataDictionary = array_merge( $this->customFieldDictionary, $this->dataDictionary ); // Combine the two to be parsed to the shortcode processor. This is required for the shortcode rendering function vacancy_additional_field()

		$jobFrontend->register_shortcodes( $superDataDictionary, $this->categoryLanguage );


		$content = "";

//		$labels = $jobFrontend->getLabels();
//		$contentSections = $jobFrontend->getContentSections();
//		$labelKeysForSection = $jobFrontend->getSectionLabelKey();
		
		$sourceData = $this->getSourceData();

//        $excerpt = @$sourceData['settings']['excerpt'];
        $header = @$sourceData['settings']['header'];
		$bodytext = @$sourceData['settings']['bodytext'];
        $footer = @$sourceData['settings']['footer'];

		if(strlen(trim($header)) > 0) {
			$content .= $header;
		}

		foreach($superDataDictionary /*$this->dataDictionary*/ as $section => $value) {
			$this->cxfields[$section] = $value;
		}

//		$set = false;
//		foreach($this->dataDictionary as $section => $value)
//		{
//		    Utils_Log::info("\n*Writer.job section: {$section}*\n");
//			$this->cxfields[$section] = $value;
//
//			if(! in_array($section, $contentSections) )
//			{
//				continue;
//			}
//
//			$label_key = $labelKeysForSection[$section];
//			$section_name = $labels[$label_key];
//			$css_class = "cx2_" . @strtolower(@end(@explode(".", $label_key)));
//
//			$content .= "<h4 class='cx_h4 $css_class'>$section_name</h4> <div class='$css_class'>$value</div> ";
//
//			if(!$set)
//			{
//				$this->fragment = $content;
//				$content .= '<!--more-->';
//				$set = true;
//			}
//		}


		if(strlen(trim($bodytext)) > 0) {
            $content .= do_shortcode($bodytext);
        }


		/**
		 * [cx_apply_button] shortcode is not mandatory anymore in Sources->Source edit->Publication Details Footer
		 *
		 * @since 2.20.1
		 */
        if(strlen(trim($footer)) <= 0) {
            // $footer = '[cx_apply_button]';
            $footer = '';
        }
        
        if(strlen(trim($footer)) > 0) {
            $content = $content .$footer;
        }
        
		return $content;
	}

	public function getTitle() 
	{
        $title = '';
		if(isset($this->dataDictionary['title']))
		{
			$title = $this->dataDictionary['title'];
		}
		elseif(isset($this->dataDictionary['titleInformation']))
		{
			$title =$this->dataDictionary['titleInformation'];
		}
        
		return $title;
	}
	
	public function getExcerpt() : string
	{
		// Job shortcodes need to be processed for the backend for the Sources->"Publication Details Body" template
		$jobFrontend = new Frontend_Shortcode_Job();
		$jobFrontend->register_shortcodes( $this->dataDictionary, $this->categoryLanguage );

		$sourceData = $this->getSourceData();

		$excerpt = $sourceData['settings']['excerpt'] ?? "";
		$excerpt = trim($excerpt);

		if(strlen($excerpt)) {
			$excerpt = do_shortcode($excerpt);
		}

		return $excerpt;
	}

	public function getCorrespondingID()
	{

		if(isset($this->dataDictionary['guid']))
		{
			return $this->dataDictionary['guid'];
		}
		if(isset($this->dataDictionary['publicationID']))
		{
			return $this->dataDictionary['publicationID'];
		}
		
		return false;
	}
	
	public function getPublishDate()
	{
		if(isset($this->dataDictionary['pubDate']))
		{
			return $this->dataDictionary['pubDate'];
		}
		if(isset($this->dataDictionary['publicationStart']))
		{
			return $this->dataDictionary['publicationStart'];
		}
		
		return false;
	}
	
    public function postWrite($post_id) {
        $categoryLanguage = $this->categoryLanguage;
        if(!$categoryLanguage) $categoryLanguage = $this->interfacer->get_default_site_language();

		$medium_code = strtolower(trim($this->dataDictionary['medium'])); // e.g.: web, web-en, web-fr etc.

        if($medium_code == "web" || $medium_code == "web-{$categoryLanguage}") {
            $labels = Utils_Labels::get($this->categoryLanguage);
            $resource = 'resource_category_'. str_replace('.', '_', 'general.header.publications');
            $categoryKey = Environment_Settings::_setting_get($resource . '_' . $categoryLanguage);

            if(!$categoryKey) {
                $categoryKey = $labels['general.header.publications'];
            }
        } else {
            $categoryKey = trim($this->dataDictionary['medium']);
        }

	    /**
	     * Category hierarchy
	     */
        $categories = array();
        
//        if (isset($this->dataDictionary['branche0'])) {
//            $categories[] = $this->dataDictionary['branche0'];
//        }
//        if (isset($this->dataDictionary['branche1'])) {
//            $categories[] = $this->dataDictionary['branche1'];
//        }
        if (isset($this->dataDictionary['function0'])) {
            $categories[] = $this->dataDictionary['function0'];
        }
        if (isset($this->dataDictionary['function1'])) {
            $categories[] = $this->dataDictionary['function1'];
        }
        if (isset($this->dataDictionary['toWorkLevelNode'])) {
            $categories[] = $this->dataDictionary['toWorkLevelNode'];
        }
		// Removed 'business line' in this hierachy @since v2.23.0
//        if (isset($this->dataDictionary['businessLine'])) {
//            $categories[] = $this->dataDictionary['businessLine'];
//        }

        if (Environment_Settings::getSkipMainCategory() !== 'on') { // Put maincat "vacatures/publications" in front
            array_unshift($categories, $categoryKey);
        }
	    $appendLangCodeSuffix = Environment_Settings::getAppendLanguageSuffix() == "on";

//	    Utils_Log::info("\nEntity/Writer/Job.php -> postWrite()\n" . print_r($categories, true) . "\n\n");

	    /**
	     * 1. Take the vacancy's function0, function1, worklevelnode and businessline fields and optionally create
	     *    Wordpress categories for it (Dashboard->Posts->Categories).
	     * 2. Link the vacancy post to these categories
	     */
	    $this->interfacer->entity_link_category($post_id, $categories, $this->categoryLanguage, $appendLangCodeSuffix);
        
        // tags from function level, region, location
        $tags = array_filter( array(
            @$this->dataDictionary['category'], 
            @$this->dataDictionary['workLocation'],
            @$this->dataDictionary['country1'],
            @$this->dataDictionary['region1'],
            @$this->dataDictionary['country2'],
            @$this->dataDictionary['region2'],
            @$this->dataDictionary['country3'],
            @$this->dataDictionary['region3'],
        ));
        // tags from requiredInfo
        
        $requiredEducations = @$this->dataDictionary['requiredEducations'];
        $retags = array();
        if(is_array($requiredEducations)) {
            
            foreach($requiredEducations as $requiredEducation) {
                $_e = array_filter(explode(':|:', $requiredEducation));
                $_e = array_map('trim', $_e);
                $retags = array_merge($retags, $_e);
            }
        }
        $tags = array_merge($retags, $tags);
        $tags = array_filter($tags);

        $this->interfacer->entity_set_tags($post_id, $tags);
        
        //$this->interfacer->entity_set_taxonomy($taxonomy_name, $entity_id, $taxonomies);
        $countries = array_filter(array(@$this->dataDictionary['country1'],@$this->dataDictionary['country2'], @$this->dataDictionary['country3']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_COUNTRY,$post_id, $countries);
        
        $regions = array_filter(array(@$this->dataDictionary['region1'], @$this->dataDictionary['region2'], @$this->dataDictionary['region3']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_REGION,$post_id, $regions);
        
        $workLocations = array_filter(array( @$this->dataDictionary['workLocation']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_WORKLOCATION, $post_id, $workLocations);
        
        /* $function = array_filter(array( @$this->dataDictionary['category']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_FUNCTION, $post_id, $function);*/
        
        $sector = array_filter(array( @$this->dataDictionary['branche0']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_SECTOR, $post_id, $sector);
        
        $industry = array_filter(array( @$this->dataDictionary['branche1']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_INDUSTRY, $post_id, $industry);

        $functiongroup = array_filter(array( @$this->dataDictionary['function0']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_FUNCTIONGROUP, $post_id, $functiongroup);

        $function = array_filter(array( @$this->dataDictionary['function1']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_FUNCTION, $post_id, $function);
        
        $worklevel = array_filter(array( @$this->dataDictionary['toWorkLevelNode']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_WORKLEVEL, $post_id, $worklevel);
        
        $procedure = array_filter(array(@$this->dataDictionary['procedure']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_PROCEDURE, $post_id, $procedure);

        $businessLine = isset($this->dataDictionary['businessLine']) ? array_filter(array($this->dataDictionary['businessLine'])) : array('');
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_BUSINESSLINE, $post_id, $businessLine);

        $contractType = array_filter(array(@$this->dataDictionary['contractType']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_CONTRACTTYPE, $post_id, $contractType);

	    $hoursPerWeek = array_filter(array(@$this->dataDictionary['hoursPerWeek']));
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_HOURSPERWEEK, $post_id, $hoursPerWeek);


	    $isSalaryPublic = isset($this->dataDictionary['isSalaryPublic']) ? array_filter(array($this->dataDictionary['isSalaryPublic'])) : array('');
	    $minSalary = array_filter(array(@$this->dataDictionary['minSalary']));
	    $maxSalary = array_filter(array(@$this->dataDictionary['maxSalary']));
	    if ( empty($isSalaryPublic)) {
			$minSalary = $maxSalary = array('');
	    }
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_MINSALARY, $post_id, $minSalary);
        $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_MAXSALARY, $post_id, $maxSalary);


        $educations = array_filter(@$this->dataDictionary['educations']);
	    $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_EDUCATION, $post_id, $educations);

	    /**
	     * Set vacancy groups (can be multiple)
	     * You can find these in Dashboard->Posts->Group job
	     * The slug is based on the group name. If the "code" field is set in Carerix, the slug will be based on that
	     * Finally, if the WP administrator changes the slug by the Dashboard, it will be respected
	     */
        $groups = @$this->dataDictionary['groups'];
	    $groupsExportCode = @$this->dataDictionary['groupsExportCode'];
        $term_ids = $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_JOBGROUP, $post_id, $groups, true);
	    if ( !empty($groupsExportCode) )
	    {
	    	if ( !empty($term_ids) ) {
	    		$arrIdx = 0;
			    foreach ($term_ids as $termId)
			    {
				    $term = get_term($termId, WP_Constants::TAXONOMY_JOBGROUP);
				    $current_slug = $term->slug;
			    	$orig_slug_based_on_groupname = sanitize_title($groups[$arrIdx]);
			    	$new_slug_based_on_exportcode = $groupsExportCode[$arrIdx];
			    	if ( strlen($new_slug_based_on_exportcode) && $current_slug == $orig_slug_based_on_groupname) {
					    wp_update_term($termId, WP_Constants::TAXONOMY_JOBGROUP, array('slug' => $new_slug_based_on_exportcode));
				    }
				    $arrIdx++;
	    		}
		    }
	    }

	    $pubIdList = @$this->dataDictionary['pubIdList'];
	    $this->interfacer->entity_set_taxonomy(WP_Constants::TAXONOMY_PUBIDLIST, $post_id, $pubIdList);

	    /**
	     * Process the Additional Fields as public taxonomies
	     * (They are also available as meta-fields)
	     */
	    foreach($this->customFieldDictionary as $field_name => $field_value)
	    {
			if ( strpos($field_name, WP_Constants::ADDITIONAL_FIELD_PREFIX) === false  ) continue; // field prefix not found, so skip
			$fieldNameWithDashes = str_replace("_", "-", $field_name);

		    if ($field_value === WP_Constants::ADDITIONAL_FIELD_DELETED_KEY) {
			    $this->interfacer->entity_set_taxonomy($fieldNameWithDashes, $post_id, array(), true);
		    } elseif ( is_array($field_value) ) {
			    $this->interfacer->entity_set_taxonomy($fieldNameWithDashes, $post_id, $field_value, true);
		    } else {
			    $this->interfacer->entity_set_taxonomy($fieldNameWithDashes, $post_id, array($field_value), true);
		    }
	    }



	    $medium = trim($this->dataDictionary['medium']);
        $this->interfacer->entity_set_property($post_id, 'medium', $medium);
        
        if(isset($this->dataDictionary['introInformation']) && strlen(trim($this->dataDictionary['introInformation'])) > 0) {
            $meta_desc = trim($this->dataDictionary['introInformation']);
            if (Environment_Settings::getSkipYoastMeta() == false) {
	            $this->interfacer->entity_set_property($post_id, '_yoast_wpseo_metadesc', $meta_desc);
            }
        }
	}
	
	/**
	 * @deprecated This was (once) used for creating a vacancy list table
	 *
	 * @param $post_id
	 *
	 * @return string
	 */
	public function getFragment($post_id)
	{
        $labels = Utils_Labels::get();
		$link = $this->interfacer->get_post_permalink($post_id);
		$content  = "<h2 class='cx_h2'><a href='$link'>".$this->getTitle()."</a></h2>";
		$content .= $this->fragment ;
        $content .= '<a href="' . $link .'">'.$labels['general.actionLink.readMore'].' &raquo; </a>';
		return $content;
	}
	
	public function setCategoryLanguage($language) {
		$this->categoryLanguage = $language;
	}
    
    public function setCategoryKey($category) {
        $this->categoryKey = $category;
    }

    public function setSourceData($sourceData) {
        $this->sourceData = $sourceData;
    }
    
    public function getSourceData()
    {
        return $this->sourceData;
    }

    /**
     * Allow the slug of the job post to change according to its title
     * @return title
     */
    public function getSlug() {
        $title = $this->getTitle();
        return sanitize_title(JTransliteration::transliterate($title));
    }


	/**
	 * writes the job-post in the wordpress database
	 *
	 * @return integer|boolean
	 */
	public function write() {
		/**
		 * return false if it can not find the carerix_user
		 */
		if(isset($this->dataDictionary['ownerName'])
			&& strlen(trim($this->dataDictionary['ownerName'])) > 0) {
			$nicename = $this->dataDictionary['ownerName'];
		} else {
			$nicename = WP_Constants::CARERIX_USER_NICENAME;
		}

		$nicename = trim(sanitize_user($nicename, true));

		$user_id = $this->interfacer->user_id_by_login($nicename);
		if($user_id === FALSE)
		{
			// the user doesn't exist, so create it
			$user_id = $this->interfacer->user_insert($nicename, Environment_Installation::randomPassword());

			if ($user_id === FALSE) {
				return FALSE;
			}
		}

		/**
		 * if it can not get a publish date, it will use the current date
		 */
		$publishDate = $this->getPublishDate();
		if(!$publishDate)
		{
			$publishDate = date('Y-m-d');
		}
		else
		{
			$publishDate = date('Y-m-d', strtotime((string)$publishDate));
		}

		$data = array(
			'post_title' => $this->getTitle(),
			'post_type' => $this->postType,
			'post_content' => $this->getContent(),
			'post_date' => $publishDate,
			'post_author' => $user_id,
		);

		$excerpt = trim($this->getExcerpt());
		if ( strlen($excerpt) ) {
			$data['post_excerpt'] = $excerpt;
		}

		$slug = $this->getSlug();
		if ($slug) {
			$data['post_name'] = $slug;
		}

		/**
		 * check if a post with this corresponding id exists in the database
		 * if it exists, update it
		 * otherwise, insert it
		 */

		/* @var array Array of stdClass Objects with key 'post_id' */
		$post_ids_arr = $this->interfacer->entities_get_where_property($this->getType(), $this->getCorrespondingID());

		$post_count = count($post_ids_arr);

		if ($post_count == 0 ) {
			$data['post_status'] = 'publish';
			$post_id = $this->interfacer->entity_insert($data);
		} else {
			$post_id = $post_ids_arr[0]->post_id;
			$d = $this->interfacer->entity_get($post_id); // Get the full post

			if ( !is_null($d) ) {
				$data['post_status'] = @$d['post_status'];
				if ( $data['post_status'] == 'trash' ) {
					return $post_id;
				}

				$this->interfacer->entity_update($post_id, $data);
				wp_cache_delete( $post_id, 'posts' );
			} else {
				return FALSE;
			}
		}


		/**
		 * set the corresponding ID for this post.
		 */
		$this->interfacer->entity_set_property($post_id, $this->getType(), $this->getCorrespondingID());

		$this->interfacer->entity_set_property($post_id, 'managed_by', WP_Constants::META_KEY_PREFIX);


		/**
		 * Process the Additional Fields as meta-fields
		 * (They are also available as public taxonomies)
		 */
		foreach($this->customFieldDictionary as $field => $value)
		{
			$this->interfacer->entity_set_property($post_id, $field, $value);
		}

		/**
		 * if the writer has a postWrite method,
		 * launch it with the post id as parameter
		 */
		if( method_exists($this, 'postWrite') )
		{
			$this->postWrite($post_id); // @todo: optimize. It can take up to 1 sec to execute. (wp_set_post_terms() is slow)
		}

		$extra = array();
		if ( isset($this->cxfields) ) { // Defined in Writer\Job.php
			$extra[] = $this->cxfields;
		}

		do_action( 'cxwordpress_post_updated', array($post_id), array($data), $extra );

		/**
		 * return the post id parameter
		 */
		return $post_id;
	}


}