<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 9:29:42 AM
 * @version $Rev$
 */


/**
 * Job class
 * Used to ....
 */
class Entity_Writer_People extends Entity_Writer {
	
	protected $type = WP_Constants::ENTITY_TYPE_PEOPLE;
	protected $postType = 'page';
    protected $introText = '';


    public function setIntroText($introText) {
        $this->introText = $introText;
    }
    
	public function getContent() 
	{
		$labels = Utils_Labels::get();
		$phone_number_label = $labels['CxPortal.message.field.phoneGeneral'];
		$mobile_number_label = $labels['general.message.field.mobile'];
		$email_label = $labels['general.message.field.email'];
		
		$content = '';
		
        $content .= $this->introText . '<br />';
        
		foreach($this->dataDictionary as $item)
		{
			if(	   isset($item['users']) 
				&& is_array($item['users'])
				&& isset($item['users']['user'])
				&& is_array($item['users']['user'])
				&& count($item['users']['user']) > 0 
			)
			{
				$content .= "<h4 class='cx_h4'>{$item['name']}</h4>";
				$content .= "<h5 class='cx_h5'>{$item['visitCity']}</h5>";
				
				foreach($item['users']['user'] as $user)
				{
					$content .= "<h5 class='cx_h5'>{$user->firstName} {$user->lastName}</h5>";
					$content .= "<table>";
					$content .= "<tr><td>$phone_number_label</td><td>{$user->phoneNumberBusiness}</td></tr>";
					$content .= "<tr><td>$mobile_number_label</td><td>{$user->mobileNumberBusiness}</td></tr>";
					$content .= "<tr><td>$email_label</td><td>{$user->emailAddressBusiness}</td></tr>";
					$content .= "</table>";
				}
			}
		}
		
		return $content;
	}

	public function setTitle($title)
	{
		$this->dataDictionary['title'] = $title;
	}
	
	public function getTitle() 
	{
		if(isset($this->dataDictionary['title']))
		{
			return $this->dataDictionary['title'];
		}
		
		return '';
	}
	
	public function setCorrespondentID($id)
	{
		$this->dataDictionary['guid'] = $id;
	}
	
	public function getCorrespondingID()
	{
		if(isset($this->dataDictionary['guid']))
		{
			return $this->dataDictionary['guid'];
		}
		
		return false;
	}
	
	public function getPublishDate()
	{
		if(isset($this->dataDictionary['date']))
		{
			return $this->dataDictionary['date'];
		}
		
		return date('Y-m-d H:i:s');
	}

    public function getSlug() {
        return false;
    }
}