<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Sep 5, 2013 8:55:47 AM
 * @version $Rev$
 */

use Carerix\Api\Rest\Entity\CRPublication;

/**
 * OpenForm class
 * Used to ....
 */
class Frontend_Shortcode_OpenForm {

    protected $params = array();
	protected const form_id_param = 'openformid';
	protected const pub_id_param = 'openpubid';

    public function __construct() {
        ;
    }

	/**
	 * @param $params  string openformid|openpubid|function (id)|businessline (id?)
	 *
	 * @return string
	 * @throws Exception
	 */
    public function run($params) {
        $this->params = $params;

        $preselect = array();
		// @todo: preselections (param function or businessline) don't work
/*        if (isset($params['function'])) {
            if (!isset($params['businessline'])) {
	            die( $params['function'] );
	            $parent = Entity_Form_EmployeeApply::get_parent((int) $params['function']);
            } else {
	            $parent = $params['businessline'];
            }

            $preselect['wishes[desiredFunction1]'] = (int) $parent;
            $preselect['wishes[desiredFunction1]_child'] = (int) $params['function'];
        }
*/

        if (!isset($params[self::form_id_param])) {
            return '<span style="color: red;"> Required form id parameter not found </span>';
        }

        $publication_id = $params[self::pub_id_param] ?? false;

        $form_id = $params[self::form_id_param];

        $form_source = new Entity_Form((int) $form_id);
        $formData = $form_source->getData();
        $formData['settings'] = unserialize($formData['settings']);

		$is_open_application = false;
        if (!$publication_id) {
            $publications = CRPublication::findAll(array('qualifier' => 'toVacancy.isOpenApplication = 1', 'show' => array('publicationID', 'toVacancy.isOpenApplication')));
            $publication = null;
            foreach ($publications as $p) {
                $publication = $p;
                break;
            }
            if ($publication !== null) {
                $publication_id = $publication->getId();
	            $is_open_application = true;
            }
        } else {
	        // Check if the publication is an open application
	        $interfacer  = WP_Interfacer::getInstance();
	        $properties  = $interfacer->entity_get_properties(get_the_ID());
	        $pub_id      = $properties['guid'][0];
			if ($pub_id != $publication_id) $is_open_application = true;
        }

	    return Entity_Form_EmployeeApply::display($formData['settings'], $publication_id, $preselect, $is_open_application);
    }

}
