<br>

<div id="cx_diagnostics_accordion">
    <h3 id="tab_general">General</h3>
    <div>
        <table id="datatable_general" class="cell-border stripe">
            <thead>
                <th>Item</th>
                <th>Value</th>
            </thead>
            <tbody></tbody>
        </table>
    </div>

    <h3 id="tab_activepublications">Active job publications in your live Carerix system</h3>
    <div>
	    <?php
            $interfacer = WP_Interfacer::getInstance();
            $medium_codes_arr = $interfacer->getMediumCodesFromRegisteredSources();
            $medium_codes = implode(", ", $medium_codes_arr);
	    ?>
        <p>
            Active job publications are "Carerix job orders" which are published to media (medium-channels) and configured in this plugin (see: Carerix->Sources) and optionally in the 3rd party WPML plugin.<br>
            Based on your configuration, all publications for the medium codes <span style="color: #00adee;"><?php echo $medium_codes; ?></span> fitting the timespan (startdate / enddate) will be displayed below.<br>
            You can enter a term in the search-box to filter the results. To show all publications of a specific medium-code, enclose it in double quotes like this: <code>"<?php echo $medium_codes_arr[count($medium_codes_arr)-1]; ?>"</code>
        </p>
        <p>
            Take note of the column "Sensitive data". In particular Recruitment Agencies might not want to disclose their Client name. In your Carerix
            application you can hide data like "Client name" and "Salary".
        </p>
        <table id="datatable_activepublications" class="cell-border stripe">
            <thead>
                <th>Publication ID / Medium Code</th>
                <th>Publication Title</th>
                <th>Job Order ID / Title</th>
                <th>Start date &rarr; Last date</th>
                <th>Office</th>
                <th>Visibility sensitive data</th>
            </thead>
            <tbody></tbody>
        </table>
    </div>

    <h3 id="tab_mediumchannels">Available medium-channels in your live Carerix system</h3>
    <div>
        <p>
            In your Carerix system you can publish "job orders" (vacancies) to one or more medium-channels. Published vacancies are called "publications".
            In this plugin you can configure which medium (one or more) will be used for retrieving the publications.
            By default, the medium <b><i>.Eigen website</i></b> (<i>.Own website</i>) is used, identified by the medium-code <b><i>web</i></b>.
            If you want to use a different or an additional medium-channel, you can choose them in the table below (marked in green) and configure it in WP Dashboard->Carerix->Sources->Tab Jobs.
        </p>

        <table id="datatable_mediumchannels" class="cell-border stripe">
            <thead>
                <th>Code</th>
                <th>Name</th>
                <th>HTML support</th>
                <th>Notes</th>
            </thead>
            <tbody></tbody>
        </table>

    </div>
</div>

<?php
$js = <<<EOT
jQuery(document).ready( function($) {
    cx_diagnostics.populateDataTableGeneral();
    // cx_diagnostics.populateDataTableActiveJobPublications();
    // cx_diagnostics.populateDataTableMediumChannels();    
});
EOT;
    wp_register_script( 'file-handle-footer', '', [], '', true );
    wp_enqueue_script( 'file-handle-footer'  );
    wp_add_inline_script( 'file-handle-footer', $js);
?>