<?php /** @noinspection PhpUndefinedVariableInspection */ ?>

<form method="post" class="undoable">
    <?php wp_nonce_field('googleforjobs', '_carerix_nonce_field');
    $xml_sitemap_link = get_bloginfo('url') . '/?carerix_sitemap';
    // $example_apply_link = get_bloginfo('url') . '/financial-controller-32hrs-rotterdam/<span style="background-color: #e1d395">?apply=true</span>';
    $url_to_sources = get_admin_url() . "admin.php?page=carerix_sources_page&tab=carerix_sources_jobs_page";
    ?>

    <table class="form-table">
        <tbody>
        <tr valign="top">
            <th scope="col" colspan="2">
                <div class="carerix_msgBox carerix_note">
                    You can improve the job seeking experience by adding job posting structured data to your job posting web pages. Adding structured data makes your job postings eligible to appear in a special user experience in Google Search results.<br>
                    <br>
                    Hint: Register the URL <a href="<?php echo $xml_sitemap_link;?>" target="_blank"><?php echo $xml_sitemap_link;?></a> as a sitemap in Google Search Console for faster vacancy indexing!
                </div>
            </th>
        </tr>
        </tbody>
    </table>

    <ul>
        <li class="itemDetail">
            <h2 class="itemTitle">Google For Jobs activation</h2>

            <table class="form-table">
                <tbody>
                <tr valign="top">
                    <td scope="row">
                        By enabling, job posting structured data is added to the job description pages.<br>
                        <br>
                        Make sure you understand the following:<br>
                        <ol style="list-style:decimal; padding-left: 4px; margin-top:0;">
                            <li style="margin-bottom: 4px;">In your Carerix application, the vacancies (job orders) has to be set to <b>anonymous</b> if you don't want the <b>hiring organization</b> and the <b>job location</b> publicly shared;</li>
                            <li style="margin-bottom: 4px;">If you want to share <b>Purchase rate/Salary low/high</b> too, activate the 'Synchronize by REST-API' option in the Settings tab. The <b>Publish Salary</b> checkbox in your Carerix application will be respected too;</li>
                            <li style="margin-bottom: 4px;">If you decide to <b>enable</b> Google For Jobs support, it's up to Google to decide when those settings are respected and reflected in the Google For Jobs widgets;</li>
                            <li style="margin-bottom: 4px;">If you decide to <b>disable</b> Google For Jobs support at a later time, it's up to Google to decide when those settings are respected and removed from the Google For Jobs widgets.</li>
                        </ol>
                    </td>
                </tr>
                </tbody>
            </table>

            <table class="form-table">
                <tbody>
                    <tr valign="top">
                        <td valign="left" colspan="2">
                            <label>
                                <input type="checkbox" name="googleforjobs_enabled" id="googleforjobs_enabled" <?php echo $checked = @$googleforjobs_enabled == 'on' ? 'checked' : '';  ?> >
                                Enable Google For Jobs support
                            </label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </li>
    </ul>


    <ul>
        <li class="itemDetail">
            <h2 class="itemTitle">Direct apply</h2>

            <table class="form-table">
                <tbody>
                <tr valign="top">
                    <td scope="row">
                        This setting gives your applicants a <i>direct apply</i> experience right from Google Search. They will be redirected to the application form of the vacancy on this site.<br>
                        <br>
                        Make sure you understand the following:<br>
                        <ol style="list-style:decimal; padding-left: 4px; margin-top:0;">
                            <li style="margin-bottom: 4px;">Your published vacancy-pages must meet <a href="https://developers.google.com/search/docs/advanced/structured-data/job-posting#direct-apply" target="_blank">Google's requirements</a>.<br>
                                By default, this plugin uses a separate page to show the <i>application form</i>. This <i>may</i> not meet <a href="https://developers.google.com/search/docs/advanced/structured-data/job-posting#direct-apply" target="_blank">Google's requirements</a>. Therefore the safest way is to show the <i>application form</i> in the original vacancy pages.<br>
                                You can do this by replacing the shortcode <span style="background-color: #e1d395">[cx_apply_button]</span> with <span style="background-color: #e1d395">[cx_apply_form]</span> in the section <i>Publication Details Footer</i> of the Sources (see <a href="<?php echo $url_to_sources; ?>">Dashboard->Carerix->Sources</a>).<br>
                                From now on, the <i>apply button</i> (which links to a separate application page) is replaced by the application form.
                            </li>
                            <li style="margin-bottom: 4px;">This is not an instant on/off switch but a directive for Google. It could take some time before Google has updated your changes.</li>
                        </ol>
                    </td>
                </tr>
                </tbody>
            </table>

            <table class="form-table">
                <tbody>
                <tr valign="top">
                    <td valign="left" colspan="2">
                        <label>
                            <input type="checkbox" name="directapply_enabled" id="directapply_enabled" <?php echo $checked = @$directapply_enabled == 'on' ? 'checked' : '';  ?> >
                            Enable Direct Apply directive
                        </label>
                    </td>
                </tr>
                </tbody>
            </table>
        </li>
    </ul>


    <ul>
        <li class="itemDetail">
            <h2 class="itemTitle">Replacement settings for anonymous vacancies/job orders</h2>

            <table class="form-table">
                <tbody>
                    <tr valign="top">
                        <td scope="row">
                            When a vacancy is marked as <b>anonymous</b> (Carerix -> Job order -> Tab general -> Section General->Settings: Anonymous job order),
                            the following settings will be used in the structured data.
                        </td>
                    </tr>
                </tbody>
            </table>

            <table class="form-table">
                <tbody>
                    <tr valign="top">
                        <th scope="row">
                            <label>Hiring organization</label>
                        </th>
                        <td>
                            <input type="text" name="googleforjobs_organization" class="regular-text" value="<?php echo $googleforjobs_organization; ?>" />
                        </td>
                    </tr>
                </tbody>
            </table>

            <table class="form-table">
                <tbody>
                    <tr valign="top">
                        <th scope="row">
                            <label>Hiring organization logo</label>
                        </th>
                        <td>
                            <?php
                            // https://wordpress.stackexchange.com/questions/235406/how-do-i-select-an-image-from-media-library-in-my-plugin
                            // https://codex.wordpress.org/Javascript_Reference/wp.media
                            if( intval( $myprefix_image_id ) > 0 ) {
                                // Change with the image size you want to use
                                $image = wp_get_attachment_image( $myprefix_image_id, 'medium', false, array( 'id' => 'myprefix-preview-image' ) );
                            } else {
                                // Some default image
                                $image = '<img id="myprefix-preview-image" src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==" alt="" />';
                            }
                            ?>
                            <?php echo $image; ?>
                            <br>
                            <?php // echo "ID: {$myprefix_image_id}"; ?>
                            <input type="hidden" name="myprefix_image_id" id="myprefix_image_id" value="<?php echo esc_attr( $myprefix_image_id ); ?>" class="regular-text" />
                            <input type='button' class="button-primary" value="<?php esc_attr_e( 'Select logo', 'mytextdomain' ); ?>" id="myprefix_media_manager"/>
                            <input type='button' class="button hidden" value="Remove" id="myprefix_logo_remove" />
                        </td>
                    </tr>
                </tbody>
            </table>
        </li>
    </ul>

    <p class="submit">
        <input type="submit" name="submit" id="submit" class="button button-primary" value="Save changes">
    </p>
</form>