<div style="max-width: 800px;">
<h2>Getting started</h2>

<p>
	The following instructions will connect your site to the Carerix system in a minimal manner. After completing these steps, all published vacancies are retrieved and available in your WordPress site.<br>
	Visit the <a href="https://help.carerix.com/nl/articles/1958063-carerix-wordpress-plugin" target="_blank">CX WordPress Plugin Wiki</a> for more detailed information.
</p>

<ol>
	<li>
		In the Settings of this plugin, fill in the <i>Carerix Application Name</i> add the <i>Application Token</i> to connect with the Carerix System and click Save.<br>
		(If you do not have this, an authorized contact person can contact the Carerix Helpdesk and request this information)
	</li>

	<li>
		<p>
			The vacancy synchronization is started. Wait until it completes and go to the regular WordPress posts.<br>
			If vacancies are correctly published in the Carerix System, you should see them listed in the category <i>vacancies</i>.
		</p>
		A vacancy will become available in WordPress if it meets the following requirements in the Carerix System:
		<ul style="list-style: disc; margin-left:20px;">
			<li>The <i>job order</i> is published to the medium ".own website" (with medium-code <i>web</i>)</li>
			<li>The current date is located between all start/end date fields of both the <i>publication</i> and the underlying <i>job order</i></li>
		</ul>
		<p>
			<b>Tip! The information under the Diagnostics tab might help you find any problems.</b>
		</p>
	</li>

	<li>
		In the WordPress backend pick one of the vacancy posts (under regular WordPress posts) and open it to view it on the front-end.
	</li>

	<li>
		Note that an Apply link/button appears below the vacancy-post text.<br>
		<ul style="list-style: disc; margin-left:20px;">
			<li>If you click on it, the current (post) URL will be appended by "<i>?apply=true</i>"</li>
			<li>
				At that point the CX WP Plugin will replace the vacancy text by the application form<br>(After filling in, the data is sent (in realtime) to the Carerix System and becomes available as a <i>Match</i>)
			</li>
		</ul>
	</li>

    <li>
        If you want to display a list of vacancies you can (simply) use the WordPress category (page/template), targetting it on the posts-category 'vacancies'.<br>
        Most of the time a category template is included in your theme. If you make use of a pagebuilder like Elementor, WPBakery, Divi builder etc., you can
        design a listing page from there.<br>
        Also search and filtering options (based on the vacancy post taxonomies and meta fields) can be defined and set up by third party plugins like Divi Machine, Crocoblock
        Jet Smartfilters, Search &amp; Filter (Pro), Filter Everything etc.<br>
        The CX WP Plugin has also a searchwidget included, but can only be used for simple websites.
    </li>

	<li>
		Apply styling.<br>
		<ul style="list-style: disc; margin-left:20px;">
			<li>
				You can add your own CSS styling in your theme to apply to the vacancy text and the application form. Basically all elements have a unique class or identifyer.<br>
				Also take note of the "cx-...." classes defined in the &lt;body&gt;-tag which you can use to distinguish vacancy text pages from vacancy application form pages and other WordPress pages
			</li>
		</ul>
	</li>

	<li>
		Changing the vacancy text layout.<br>
		<ul style="list-style: disc; margin-left:20px;">
			<li>
				You can also change the order of vacancy elements (like introduction, requirements, offer) or add new elements like <i>salary</i>.<br>
				To do that, you need to edit the vacancy template. You can find the template under the CX WP Plugin menu option "Sources".<br>
				The template is build up by shortcodes. You can find a complete list of available shortcodes in this help section under the tab "Shortcodes".<br>
				Most of the shortcodes can also be used in your theme or pagebuilder (Elementor, WPBakery, Divi builder etc)!
			</li>
		</ul>
	</li>

	<li>
		Changing the application form fields. You can pick the (most common) fields from a list which you want to show on the application form.<br>
		<ul style="list-style: disc; margin-left:20px;">
			<li>
				Go to the CX WP Plugin menu option "Application forms" and open the form of your preference (initially there's only one)
			</li>
			<li>
                Tick the checkboxes of the fields you want to use in the appliction form. You can change the order of the fields <i>within its section</i> by mouse-dragging
                the fields to other positions.<br>
                In the "Section Order" you can change the section order by dragging the sections thereselves with the mouse.<br>
			</li>
            <li>
                Finally, note the "Settings" tab where you can set up an Agreement text and a Captcha test.
            </li>
		</ul>
	</li>

</ol>
</div>